unit Const1;

(*
 * Delphi Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2006 Huw Collingbourne 
 *
 *)
 
{  Show how to declare global and local Constants }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


{ Global Constants
  These aren't as 'bad' as global variables since, being constant,
  their values cannot change during program execution. So they can't
  cause the same unexpected 'side-effects' as global variables }
const
  LOOPLIMIT = 4;
  MAG = 'Bitwise Magazine';

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
const
  ThisProc = 'TForm1.Button1Click'; { local const }
var
  i : integer;
begin
// Notice again how 'With' is used to avoid repeatedly entering
// ListBox1.Items...
  With ListBox1.Items do
  begin
      for i := 1 to LOOPLIMIT do
          Add('Loop: ' + IntToStr( i ) );
      Add( 'You are reading ' + MAG );
      Add( 'Current procedure is ' + ThisProc );
  end;
end;



end.
