unit Globunit;

(*
 * Delphi Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2006 Huw Collingbourne 
 *
 *)

{ Illustrates the usage of global
  variables.

  This uses a similar Proc1 procedure to the one in the FuncProc
  project. However, in FuncProc the string variable, 's' is 'local'
  to the Button1Click method and is not 'visible' to other procedures
  unless it is specifically passed as a parameter.

  In the current project, 's' is declared 'globally' - at the top of the
  unit and is, therefore, 'visible' to all procedures within the unit.
  Now, when the Proc1 procedure makes s lower-case, s remains
  lower-case when the Button1Click proc displays the string using the
  line:
    Edit2.Text := s;

  In general, avoid global variables. They can cause unexpected
  side-effects. }



interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s    : string; { s is now 'global' }
implementation

{$R *.DFM}

procedure proc1;
begin
  s := LowerCase( s );
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  s := Edit1.Text;
  proc1;
  Edit2.Text := s;
end;


end.
